using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Threading;
using System.IO;
using MAPI;
using System.Reflection;
using System.Configuration;

namespace IPCRobot
{
    public partial class FormMain : Form
    {
        #region " Variables & Enum "
        //Proceed
        private int totalMsgCount = 0;
        private int validMsgCount = 0;
        private int validAttachmentsCount = 0;
        private int AllSaved = 0;
        private int Saved = 0;
        private Boolean testMode = false;
        private String CRLF = "\n";
        private Object vEmpty = Missing.Value;

        //Output
        private StringBuilder outputLines = new StringBuilder();
        private String newOutputLine;

        //mail address
        private String strMcdMailAddr;
        private String strAdminMailAddr;
        private String arg;

        //Threading
        private delegate void delegateNoParam();

        
        #endregion

        #region " Constructor "
        public FormMain(string arg)
        {
            InitializeComponent();
            //set the argument
            this.arg = arg;
            //start the processautosave
            Thread ProcessThread = new Thread(ProcessAutosave);
            ProcessThread.SetApartmentState(ApartmentState.STA);
            ProcessThread.Start();
            //timer1.Enabled = true;
        }
        #endregion

        #region " Processing "

        public class TheSession
        {
            public TheSession() { }
            Session session = new Session ();

            public Session SetSession(){
                Session session = null;
                string exchgHostName = System.Configuration.ConfigurationManager.AppSettings.Get("strServer");
                string exchgUserName = System.Configuration.ConfigurationManager.AppSettings.Get("strName");

                //start the process
                //AddLineToOutput("Create CDO/MAPI session : Exchange server : " + exchgHostName + " , Mailbox : " + exchgUserName);

                //Session Init
                session = new Session();

                //Mailbox access
                session.Logon(string.Empty, string.Empty, false, true, 0, false, exchgHostName + "\n" + exchgUserName);

                return session;
            }
            

        }





        public class drive_Letter { 
            public drive_Letter(){}

            String driveLetter ="";
            public String SetDriveLetter(){
                 driveLetter = ConfigurationManager.AppSettings.Get("strDriveLetter");
                 //AddLineToOutput("Check network drive : " + driveLetter);
                 DriveInfo[] allDrives = DriveInfo.GetDrives();
                 Boolean driveExist = false;
                 foreach (DriveInfo drive in allDrives)
                 {
                     if (drive.Name.Substring(0,1) == driveLetter)
                     {
                         driveExist = true;
                     }
                 }
                //if the drive does not exist, create it
                if (!driveExist)
                {
                    String remotePath = ConfigurationManager.AppSettings.Get("strRemotePath");
                    //AddLineToOutput("Mount network drive : " + driveLetter + " for " + remotePath);
                    System.Diagnostics.Process p = System.Diagnostics.Process.Start("net.exe", @"use " + driveLetter + ": " + remotePath);
                    p.WaitForExit();
                }

                //Reclassification folder access
                System.IO.DirectoryInfo info = new System.IO.DirectoryInfo(driveLetter + ":");
                if (!info.Exists)
                {
                    MessageBox.Show("Unable to find network drive. The application will be closed.");
                    // No available network drive: send kill application and exit process
                    //Application.Exit();
                }
                return driveLetter;
            }

            public String GetDriveLetter(){
                if (driveLetter == null){ 
                    driveLetter = ""; 
                } 
                    return driveLetter;
                } 

         }

        private void ProcessAutosave()
        {

            
            if (arg == String.Empty)
            {
                MessageBox.Show("To run in automatic / robot mode, please start with 'auto' parameter." + CRLF + CRLF + "To run in test mode, please start with an e-mail address as parameter (name or internet address)." + CRLF + CRLF + "Warning: IPCRobot cannot start without parameter !");
            }
            else
            {
                if (arg == "auto")
                {
                    testMode = false;
                }
                else
                {
                    MessageBox.Show("IPCRobot will start in test mode. All mails will be sent to: " + arg + CRLF + CRLF + "Be sure this is a valid address !" + CRLF + CRLF + "IPCRobot running in test mode.");
                    strAdminMailAddr = arg;
                    strMcdMailAddr = arg;
                    testMode = true;
                }
            }
        }
        public void ProcessSaving()
        {


            //check if the target drive exists
            drive_Letter driveletter1 = new drive_Letter();
            String driveLetter ="";
            driveLetter = driveletter1.SetDriveLetter();
            TheSession thesession = new TheSession();
            Session session = new Session();
            session = thesession.SetSession();
            
            //Try to access to the default folder to check the logon
            Folder defaultFolder = (Folder)session.GetDefaultFolder(1);
            // Specify a "currently active folder"
            string activeDir = @driveLetter+":";

            
            // Create a new file name. This example generates
            // a random string.
            string newFileName = "heartbeat.txt";

            string newPath = System.IO.Path.Combine(activeDir, newFileName);


            using (System.IO.FileStream fs = System.IO.File.Create(newPath))
            {
                for (byte i = 0; i < 100; i++)
                {
                    fs.WriteByte(i);
                }
            }

            // Read data back from the file to prove
            // that the previous code worked.
            try
            {
                byte[] readBuffer = System.IO.File.ReadAllBytes(newPath);
                foreach (byte b in readBuffer)
                {
                    Console.WriteLine(b);
                }
            }
            catch (System.IO.IOException e)
            {
                Console.WriteLine(e.Message);
            }

            //Count the number of inbox messages
            Messages inboxMsg = (Messages)defaultFolder.Messages;

            MAPI.Folder oFolder = (MAPI.Folder)session.Outbox;
            MAPI.Messages oMsgs = (MAPI.Messages)oFolder.Messages;
            
            try{    
                //Check each message
                for (int i = 1; i <= (int)inboxMsg.Count; i++)
                {
                    totalMsgCount += 1;
                    MAPI.Message msg = ((MAPI.Message)inboxMsg.get_Item(i));
                    MAPI.Message oMsg = (MAPI.Message)oMsgs.Add(vEmpty, vEmpty, vEmpty, MAPI.CdoImportance.CdoNormal);
                    MAPI.Recipients oRecips = (MAPI.Recipients)oMsg.Recipients;
                    String msgSubject = msg.Subject.ToString();
                    //Check if the message is unread
                    if ((bool)msg.Unread == true)
                    {
                        //Check if the message subject is like IPCR RECLASSIFICATION DATA YYYYMM
                        System.Text.RegularExpressions.Regex titleRegex = new System.Text.RegularExpressions.Regex (@"IPCR RECLASSIFICATION DATA (\d{6})");
                        System.Text.RegularExpressions.Match match = titleRegex.Match(msgSubject);
                        if (match.Success)
                        {
                            validMsgCount += 1;
                            String msgYear = match.Groups[1].Value;                           
                            MAPI.AddressEntry msgSender = (MAPI.AddressEntry)msg.Sender;
                            String msgBody = (string)msg.Text;
                            String msgName = msgSender.Name.ToString(); 

                            //Check if the folder YYYYMM already exist, if not create it
                            string ipcRevisionDirectory = driveLetter + ":\\" + msgYear;
                            System.IO.DirectoryInfo ipcRevisionDirectoryInfo = new System.IO.DirectoryInfo(ipcRevisionDirectory);
                            if (ipcRevisionDirectoryInfo.Exists == false)
                            {
                                System.IO.Directory.CreateDirectory(ipcRevisionDirectory);
                             }

                            //Check if the message has an attachment
                            MAPI.Attachments msgAttachments = (MAPI.Attachments)msg.Attachments;
                            
                            int nbAttachments = (int)msgAttachments.Count;
                            if (nbAttachments > 0)
                            {
                                for(int j = 1; j < nbAttachments + 1; j++ )
                                {
                                    validAttachmentsCount += 1;
                                    MAPI.Attachment msgAttachment = (MAPI.Attachment)msgAttachments.get_Item(j);
                                    String msgAttachmentName = (string)msgAttachment.Name;
                                    //Check if the name of the attachment is like IPCR_RESULTS_
                                    System.Text.RegularExpressions.Regex titleAttRegex = new System.Text.RegularExpressions.Regex(@"IPCR_RESULTS_([A-Z]{2}).+\.((ZIP)|(XML))");
                                    String attachmentTitle = msgAttachmentName.ToUpper();
                                    System.Text.RegularExpressions.Match matchTitleAttRegex = titleAttRegex.Match(attachmentTitle);
                                     if (matchTitleAttRegex.Success)
                                    {
                                        string msgCountry = ipcRevisionDirectory + "\\" + matchTitleAttRegex.Groups[1].Value;
                                        System.IO.DirectoryInfo countryDirectoryInfo = new System.IO.DirectoryInfo(msgCountry);
                                         //Check if the corresponding country folder already exist, if not create it
                                         if (countryDirectoryInfo.Exists == false)
                                        {
                                            System.IO.Directory.CreateDirectory(msgCountry);
                                        }
                                        //Save the attachment to the dedicated folder
                                         msgAttachment.WriteToFile(msgCountry + "\\" + msgAttachmentName);
                                        Saved += 1;
                                        AllSaved += 1;

                                         //create reply message
                                         oMsg.Subject = "IPCReclassification robot: Automatic acknowledge of receipt";
                                         oMsg.Text = "This is an automatic reply indicating that your email was processed by the IPC reclassification robot." + CRLF + CRLF + "Please note that in conformity with the protocol described under http://www.wipo.int/ipcreclassification ,  the textual part of emails sent to this address may not be read by WIPO staff but is forwarded to the Master Classification Database." + CRLF + CRLF + "Should your IPC reclassification email attachment be not published within 48 hours under http://www.wipo.int/ipcreclassification, please inform claims@wipo.int" + CRLF + CRLF + "For any question in relation with the IPC itself, contact ipc.mail@wipo.int" + CRLF + CRLF + "From: " + msgName + " - Subject: " + msgSubject + " - Attachment: " + msgAttachmentName;
                   
                                         MAPI.Recipient oRecipCc ;
                                         MAPI.Recipient oRecipTo;

                                         if (testMode == false) 
                                         {
                                             // Add a new recipient TO	
                                            oRecipTo = (MAPI.Recipient)oRecips.Add(vEmpty, vEmpty, vEmpty, vEmpty);
                                            oRecipTo.Name = msgSender.Name;
                                            oRecipTo.Type = MAPI.CdoRecipientType.CdoTo;
                                            oRecipTo.Resolve(false);

                                            // Add a new recipient CC		
                                            oRecipCc = (MAPI.Recipient)oRecips.Add(vEmpty, vEmpty, vEmpty, vEmpty);
                                            oRecipCc.Name = ConfigurationManager.AppSettings.Get("strMcdMailAddr");
                                            oRecipCc.Type = MAPI.CdoRecipientType.CdoCc;
                                            oRecipCc.Resolve(false);
                                         }
                                         else
                                         {
                                             // Add a new recipient TO	
                                            oRecipTo = (MAPI.Recipient)oRecips.Add(vEmpty, vEmpty, vEmpty, vEmpty);
                                            oRecipTo.Name = arg;
                                            oRecipTo.Type = MAPI.CdoRecipientType.CdoTo;
                                            oRecipTo.Resolve(false);
                                         }
                                        oMsg.Update(true, true);
                                        oMsg.Send(false, false, 0);
                                    }
                                }
                                MAPI.Message nMsg = (MAPI.Message)oMsgs.Add(vEmpty, vEmpty, vEmpty, MAPI.CdoImportance.CdoNormal);
                                MAPI.Recipients nRecips = (MAPI.Recipients)nMsg.Recipients;
                                
                                //If no attachment save, send a warning email
                                if (Saved == 0)
                                {
                                     //create reply message
                                    nMsg.Subject = "Warning: " + msgSubject;
                                    nMsg.Text = "This is an automatic reply indicating that your email attachment could not be processed sucessfully by the IPC reclassification robot because the protocol described under http://www.wipo.int/ipcreclassification/ was not respected." + CRLF + CRLF + "Original message follow:" + CRLF + "From: " + msgName + " - Subject: " + msgSubject + CRLF + msgBody;
                                  
                                    MAPI.Recipient oRecipCc;
                                    MAPI.Recipient oRecipTo;
                                    if (testMode == false) 
                                    {
                                        // Add a new recipient TO	
                                        oRecipTo = (MAPI.Recipient)nRecips.Add(vEmpty, vEmpty, vEmpty, vEmpty);
                                        oRecipTo.Name = msgSender.Name;
                                        oRecipTo.Type = MAPI.CdoRecipientType.CdoTo;
                                        oRecipTo.Resolve(false);

                                        // Add a new recipient CC	
                                        oRecipCc = (MAPI.Recipient)nRecips.Add(vEmpty, vEmpty, vEmpty, vEmpty);
                                        oRecipCc.Name = ConfigurationManager.AppSettings.Get("strMcdMailAddr");
                                        oRecipCc.Type = MAPI.CdoRecipientType.CdoCc;
                                        oRecipCc.Resolve(false);
                                     }
                                     else
                                     {
                                         MessageBox.Show("No valid attachment was found in a message with valid subject" + CRLF + "From: " + msgName + " - Subject: " + msgSubject);
                                        // Add a new recipient TO	
                                        oRecipTo = (MAPI.Recipient)nRecips.Add(vEmpty, vEmpty, vEmpty, vEmpty);
                                        oRecipTo.Name = arg;
                                        oRecipTo.Type = MAPI.CdoRecipientType.CdoTo;
                                        oRecipTo.Resolve(false);
                                     }
                                 nMsg.Update(true, true);
                                 nMsg.Send(false, false, 0);
                                }
                                else
                                {
                                    Saved = 0;
                                    //If the body of the email is not empty, send a warning email
                                    if (msgBody.CompareTo("") > 0)
                                    {
                                        //create reply message
                                        nMsg.Subject = "IPCReclassification robot warning";
                                        nMsg.Text = "To " + msgName + " :" + CRLF + "IPC Robot found and saved valid attachment, but also detected that message body was not empty." + CRLF + "Please avoid sending text message to the robot, if you need help, please refer to IPCReclassification manual." + CRLF + "From: " + msgName + " - Subject: " + msgSubject;
                                          
                                        if (testMode == false) 
                                        {                                            
                                            //create the recipients for the message
                                            MAPI.Recipient oRecipCc;
                                            MAPI.Recipient oRecipTo;

                                             // Add a new recipient TO	
                                            oRecipTo = (MAPI.Recipient)nRecips.Add(vEmpty, vEmpty, vEmpty, vEmpty);
                                            oRecipTo.Name = msgSender.Name;
                                            oRecipTo.Type = MAPI.CdoRecipientType.CdoTo;
                                            oRecipTo.Resolve(false);

                                            // Add a new recipient CC		
                                            oRecipCc = (MAPI.Recipient)nRecips.Add(vEmpty, vEmpty, vEmpty, vEmpty);
                                            oRecipCc.Name = ConfigurationManager.AppSettings.Get("strMcdMailAddr");
                                            oRecipCc.Type = MAPI.CdoRecipientType.CdoCc;
                                            oRecipCc.Resolve(false);
                                        }
                                        else
                                        {
                                            // Add a new recipient TO	
                                            MAPI.Recipient oRecipTo;    
                                            oRecipTo = (MAPI.Recipient)nRecips.Add(vEmpty, vEmpty, vEmpty, vEmpty);
                                            oRecipTo.Name = arg;
                                            oRecipTo.Type = MAPI.CdoRecipientType.CdoTo;
                                            oRecipTo.Resolve(false);
                                        }
                                        nMsg.Update(true, true);
                                        nMsg.Send(false, false, 0);
                                    }
                                }
                            }
                        }  
                        msg.Unread = false;
                        msg.Update(true, true);
                    }
                }
                //Create report email
                MAPI.Message rMsg = (MAPI.Message)oMsgs.Add(vEmpty, vEmpty, vEmpty, MAPI.CdoImportance.CdoNormal);
                MAPI.Recipients rRecips = (MAPI.Recipients)rMsg.Recipients;
                //No valid message(s) found
                if (validMsgCount == 0)
                {
                    //create reply message
                    rMsg.Subject = "IPCReclassification robot warning";
                    rMsg.Text = "Script ran, but didn't find valid message in mailbox.";

                    if (testMode)
                    {
                        MessageBox.Show("No valid message was found in mailbox.");
                        //create the recipients for the message
                        MAPI.Recipient oRecipTo;
                        // Add a new recipient TO	
                        oRecipTo = (MAPI.Recipient)rRecips.Add(vEmpty, vEmpty, vEmpty, vEmpty);
                        oRecipTo.Name = arg;
                        oRecipTo.Type = MAPI.CdoRecipientType.CdoTo;
                        oRecipTo.Resolve(false);

                        rMsg.Update(true, true);
                        rMsg.Send(false, false, 0);
                    }
                }
                else
                {
                    //create reply message
                    rMsg.Subject = "IPCReclassification robot information";
                    rMsg.Text = "Script ran, and found valid message in mailbox." + CRLF + validMsgCount + " valid message(s) found. " + CRLF + AllSaved + " attachment(s) saved.";

                    //create the recipients for the message
                    MAPI.Recipient oRecipTo;
                    // Add a new recipient TO	
                    oRecipTo = (MAPI.Recipient)rRecips.Add(vEmpty, vEmpty, vEmpty, vEmpty);
                    oRecipTo.Name = ConfigurationManager.AppSettings.Get("strAdminMailAddr");
                    oRecipTo.Type = MAPI.CdoRecipientType.CdoTo;
                    oRecipTo.Resolve(false);

                    rMsg.Update(true, true);
                    rMsg.Send(false, false, 0);
                }
            }
            catch (Exception ex)
            {
                AddLineToOutput("Error while executing application : " + ex.Message);
            }
            finally
            {
                AddLineToOutput(Environment.NewLine + "End of processing : " + System.DateTime.Now.ToString());
                AddLineToOutput("---------------------------------------------------------------------------");
                //Application.Exit();
            }
        }
        #endregion

        #region " Output "
        private void AddLineToOutput(string _newOutputLine)
        {
            newOutputLine = _newOutputLine;
            if (this.InvokeRequired)
            {
                Invoke(new delegateNoParam(InvokeAddLineToOutput));
            }
            else
            {
                InvokeAddLineToOutput();
            }
        }

        private void InvokeAddLineToOutput()
        {
            //add new line to outputVar
            outputLines.AppendLine(newOutputLine);
            //add line to direct output
            textBox1.Text = outputLines.ToString();
            //add line to log file
        }    
        #endregion

       /* private void timer1_Tick(object sender, EventArgs e)
        {
            AddLineToOutput("inside the timer");
            ProcessSaving();
        }*/
    }
    
}
