using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.IO;
using System.Net.Mail;
using System.Reflection;
using System.Text;
using System.Threading;
using System.Windows.Forms;
using MAPI;
using Outlook = Microsoft.Office.Interop.Outlook;

namespace IPCRobot
{
    public partial class FormMain : Form
    {
        Outlook.Application oApp;
        Outlook.NameSpace oNS;


        #region " Variables & Enum "
        //Proceed
        private int totalMsgCount = 0;
        private int validMsgCount = 0;
        private int validAttachmentsCount = 0;
        private int AllSaved = 0;
        private int Saved = 0;
        private Boolean testMode = true;
        private String CRLF = "\n";
        private Object vEmpty = Missing.Value;

        //Output
        private StringBuilder outputLines = new StringBuilder();
        private String newOutputLine;

        //mail address
        private String strMcdMailAddr;
        private String strAdminMailAddr;
        private String arg;

        //Threading
        private delegate void delegateNoParam();


        #endregion

        #region " Constructor "
        public FormMain(string arg)
        {
            InitializeComponent();
            //set the argument
            this.arg = arg;
            //start the processautosave
            Thread ProcessThread = new Thread(ProcessAutosave);
            ProcessThread.SetApartmentState(ApartmentState.STA);
            ProcessThread.Start();
        }
        #endregion

        #region " Processing "
        private void ProcessAutosave()
        {
            arg = "auto";
            if (arg == String.Empty)
            {
                MessageBox.Show("To run in automatic / robot mode, please start with 'auto' parameter." + CRLF + CRLF + "To run in test mode, please start with an e-mail address as parameter (name or internet address)." + CRLF + CRLF + "Warning: IPCRobot cannot start without parameter !");
            }
            else
            {
                if (arg == "auto")
                {
                    testMode = false;
                }
                else
                {
                    MessageBox.Show("IPCRobot will start in test mode. All mails will be sent to: " + arg + CRLF + CRLF + "Be sure this is a valid address !" + CRLF + CRLF + "IPCRobot running in test mode.");
                    strAdminMailAddr = arg;
                    strMcdMailAddr = arg;
                    testMode = true;
                }
            }

            //check if the target drive exists
            String stringType2;
            String stringType;
            String driveLetter = ConfigurationManager.AppSettings.Get("strDriveLetter");
            AddLineToOutput("Check network drive : " + driveLetter);
            DriveInfo[] allDrives = DriveInfo.GetDrives();
            Boolean driveExist = false;
            foreach (DriveInfo drive in allDrives)
            {
                if (drive.Name.Substring(0, 1) == driveLetter)
                {
                    driveExist = true;
                }
            }
            //if the drive does not exist, create it
            if (!driveExist)
            {
                String remotePath = ConfigurationManager.AppSettings.Get("strRemotePath");
                AddLineToOutput("Mount network drive : " + driveLetter + " for " + remotePath);
                System.Diagnostics.Process p = System.Diagnostics.Process.Start("net.exe", @"use " + driveLetter + ": " + remotePath);
                p.WaitForExit();
            }

            //Reclassification folder access
            System.IO.DirectoryInfo info = new System.IO.DirectoryInfo(driveLetter + ":");
            if (!info.Exists)
            {
                MessageBox.Show("Unable to find network drive. The application will be closed.");
                // No available network drive: send kill application and exit process
                //Application.Exit();
                return;
            }
            // Create a new file name. This example generates
            // a random string.
            // Specify a "currently active folder"
            string activeDir = @driveLetter + ":";

            string newFileName = "robot/heartbeat/heartbeat.txt";

            string newPath = System.IO.Path.Combine(activeDir, newFileName);


            using (System.IO.FileStream fs = System.IO.File.Create(newPath))
            {
                for (byte i = 0; i < 100; i++)
                {
                    fs.WriteByte(i);
                }
            }

            //Session session = null;
            try
            {

                //start the process
                oApp = new Outlook.Application();
                oNS = oApp.GetNamespace("MAPI");
                //Mailbox access
                oNS.Logon(Missing.Value, Missing.Value, false, true);

                //Try to access to the default folder to check the logon
                //Count the number of inbox messages
                Outlook.MAPIFolder oInbox = oNS.GetDefaultFolder(Outlook.OlDefaultFolders.olFolderInbox);
                Outlook.Items oItems = oInbox.Items; //HACE DE (MAPI.Messages)oFolder.Messages;
                //AddLineToOutput("Number of emails:"+ oItems.Count);
                Outlook.MailItem bMsg = (Outlook.MailItem)oItems.GetFirst();

                for (int i = 1; i <= (int)oItems.Count; i++)
                {
                    Outlook.MailItem aMsg = (Outlook.MailItem)oApp.CreateItem(Outlook.OlItemType.olMailItem);
                    aMsg.Subject = "subject";
                    aMsg.Body = "body";
                    String systemComObject = Microsoft.VisualBasic.Information.TypeName(oItems[i]);                    
                    //AddLineToOutput(systemComObject);
                    if (systemComObject == "MailItem")
                    {
                        bMsg = (Outlook.MailItem)oItems[i];
                        Outlook.Recipients aRecips = (Outlook.Recipients)aMsg.Recipients;
                        int k = aRecips.Count;
                        String amsgSubject = aMsg.Subject.ToString();
                        String TestTo = bMsg.To;
                        String TestCC = bMsg.CC;
                        String TestMessage = bMsg.Subject;
                        AddLineToOutput(TestMessage);

                        bool ToReclassificationName = TestTo.IndexOf("reclassification, ipc", StringComparison.CurrentCultureIgnoreCase) > -1;
                        bool ToReclassificationEmail = TestTo.IndexOf("ipc.reclassification@wipo.int", StringComparison.CurrentCultureIgnoreCase) > -1;
                        //Check if the message is unread                    
                        if ((bool)bMsg.UnRead == true && (ToReclassificationName || ToReclassificationEmail))
                        {
                            //AddLineToOutput("Email processed number " + i + ":" + bMsg.Subject);

                            //Check if the message subject is like IPCR RECLASSIFICATION DATA YYYYMM
                            System.Text.RegularExpressions.Regex titleRegex = new System.Text.RegularExpressions.Regex(@"IPC RECLASSIFICATION DATA (\d{6})");
                            System.Text.RegularExpressions.Match match = titleRegex.Match(bMsg.Subject);
                            if (match.Success)
                            {
                                validMsgCount += 1;
                                String msgYear = match.Groups[1].Value;
                                String msgBody = (string)bMsg.Body;
                                String msgName = bMsg.SenderEmailAddress;

                                //Check if the folder YYYYMM already exist, if not create it
                                string ipcRevisionDirectory = driveLetter + ":www_reclassification/" + msgYear;
                                System.IO.DirectoryInfo ipcRevisionDirectoryInfo = new System.IO.DirectoryInfo(ipcRevisionDirectory);
                                if (ipcRevisionDirectoryInfo.Exists == false)
                                {
                                    System.IO.Directory.CreateDirectory(ipcRevisionDirectory);
                                }

                                //Check if the message has an attachment
                                Outlook.Attachments msgAttachments = (Outlook.Attachments)bMsg.Attachments;
                                //String TestCC = bMsg.CC;

                                int nbAttachments = (int)msgAttachments.Count;
                                if (nbAttachments > 0)
                                {
                                    Outlook.Recipient oRecipCc;
                                    Outlook.Recipient oRecipTo;


                                    if (testMode == false)
                                    {
                                        // Add a new recipient TO	
                                        /*oRecipTo = (Outlook.Recipient)aRecips.Add(bMsg.SenderEmailAddress);                                            
                                        oRecipTo.Type=1;
                                        oRecipTo.Resolve();*/
                                        aMsg.To = bMsg.SenderEmailAddress;
                                        // Add a new recipient CC		
                                        /*oRecipCc = (Outlook.Recipient)aRecips.Add(ConfigurationManager.AppSettings.Get("strMcdMailAddr"));
                                        oRecipCc.Type=2;
                                        oRecipCc.Resolve();*/

                                        aMsg.Recipients.Add(ConfigurationManager.AppSettings.Get("strMcdMailAddr"));
                                    }
                                    else
                                    {
                                        // Add a new recipient TO	
                                        oRecipTo = (Outlook.Recipient)aRecips.Add(arg);
                                        oRecipTo.Type = 1;
                                        oRecipTo.Resolve();
                                        aMsg.Recipients.Add(arg);

                                    }
                                    for (int j = 1; j < nbAttachments + 1; j++)
                                    {
                                        validAttachmentsCount += 1;
                                        AddLineToOutput("Email with valid subject");

                                        Outlook.Attachment msgAttachment = (Outlook.Attachment)msgAttachments[j];

                                        String msgAttachmentName = (string)msgAttachment.FileName;
                                        //Check if the name of the attachment is like IPCR_RESULTS_
                                        System.Text.RegularExpressions.Regex titleAttRegex = new System.Text.RegularExpressions.Regex(@"IPC_RESULTS_([A-Z]{2}).+\.((ZIP)|(XML))");
                                        String attachmentTitle = msgAttachmentName.ToUpper();
                                        System.Text.RegularExpressions.Match matchTitleAttRegex = titleAttRegex.Match(attachmentTitle);

                                        if (matchTitleAttRegex.Success)
                                        {
                                            AddLineToOutput("Email with valid attachment");
                                            string msgCountry = ipcRevisionDirectory;// +"\\" + matchTitleAttRegex.Groups[1].Value;
                                            System.IO.DirectoryInfo countryDirectoryInfo = new System.IO.DirectoryInfo(msgCountry);
                                            //Check if the corresponding country folder already exist, if not create it
                                            /*
                                              if (countryDirectoryInfo.Exists == false)
                                              {
                                                  System.IO.Directory.CreateDirectory(msgCountry);
                                              }  
                                              */
                                            //Save the attachment to the dedicated folder
                                            String nome = msgCountry + "\\" + msgAttachments[j].DisplayName;
                                            msgAttachments[j].SaveAsFile(nome);
                                            Saved += 1;
                                            AllSaved += 1;

                                            //create reply message
                                            if (aMsg.Subject == "subject")
                                            {
                                                aMsg.Subject = "IPCReclassification robot: Automatic acknowledge of receipt";
                                                aMsg.Body = "This is an automatic reply indicating that your email was processed by the IPC reclassification robot." + CRLF + CRLF + "Please note that in conformity with the protocol described under http://www.wipo.int/ipcreclassification ,  the textual part of emails sent to this address may not be read by WIPO staff but is forwarded to the Master Classification Database." + CRLF + CRLF + "Should your IPC reclassification email attachment be not published within 48 hours under http://www.wipo.int/ipcreclassification, please inform claims@wipo.int" + CRLF + CRLF + "For any question in relation with the IPC itself, contact ipc.mail@wipo.int" + CRLF + CRLF + "From: " + msgName + " - Subject: " + bMsg.Subject.ToString() + " - Attachment: " + msgAttachmentName;
                                            }
                                            

                                            //AddLineToOutput("Message sent");
                                        }
                                    }

                                    Outlook.MailItem nnMsg = (Outlook.MailItem)oApp.CreateItem(Outlook.OlItemType.olMailItem);
                                    nnMsg.Subject = "subject";
                                    nnMsg.Body = "body";
                                    Outlook.Recipients nRecips = (Outlook.Recipients)nnMsg.Recipients;
                                    //If no attachment save, send a warning email

                                    if (Saved == 0)
                                    {
                                        AddLineToOutput("Attachment could not be saved");
                                        //create reply message
                                        nnMsg.Subject = "Warning: " + bMsg.Subject.ToString();
                                        nnMsg.Body = "This is an automatic reply indicating that your email attachment could not be processed sucessfully by the IPC reclassification robot because the protocol described under http://www.wipo.int/ipcreclassification/ was not respected." + CRLF + CRLF + "Original message follow:" + CRLF + "From: " + msgName + " - Subject: " + bMsg.Subject.ToString() + CRLF + msgBody;

                                        if (testMode == false)
                                        {
                                            // Add a new recipient TO	
                                            oRecipTo = (Outlook.Recipient)nRecips.Add(msgName);
                                            oRecipTo.Type = 1;
                                            oRecipTo.Resolve();
                                            nnMsg.To = bMsg.SenderEmailAddress;
                                            // Add a new recipient CC	
                                            nnMsg.Recipients.Add((ConfigurationManager.AppSettings.Get("strMcdMailAddr")));
                                        }
                                        else
                                        {
                                            MessageBox.Show("No valid attachment was found in a message with valid subject" + CRLF + "From: " + msgName + " - Subject: " + bMsg.Subject.ToString());
                                            // Add a new recipient TO	
                                            oRecipTo = (Outlook.Recipient)nRecips.Add(arg);
                                            oRecipTo.Type = 1;
                                            oRecipTo.Resolve();
                                            nnMsg.Recipients.Add(arg);
                                        }
                                        nnMsg.Send();
                                    }
                                    else
                                    {
                                        aMsg.Send();
                                        AddLineToOutput("Attachment saved");
                                        Saved = 0;

                                        String prueba = "";
                                        prueba = (string)bMsg.Body;


                                        System.Text.RegularExpressions.Regex regexbody = new System.Text.RegularExpressions.Regex("[A-Za-z0-9_]");
                                        System.Text.RegularExpressions.Match matchbody = regexbody.Match(prueba);


                                        //If the body of the email is not empty, send a warning email
                                        if (matchbody.Success)
                                        {
                                            //create reply message
                                            nnMsg.Subject = "IPCReclassification robot warning";
                                            nnMsg.Body = "To " + msgName + " :" + CRLF + "IPC Robot found and saved valid attachment, but also detected that message body was not empty." + CRLF + "Please avoid sending text message to the robot, if you need help, please refer to IPCReclassification manual.";

                                            if (testMode == false)
                                            {

                                                //create the recipients for the message


                                                // Add a new recipient TO	
                                                oRecipTo = (Outlook.Recipient)nRecips.Add(msgName);
                                                oRecipTo.Type = 1;
                                                oRecipTo.Resolve();
                                                nnMsg.To = bMsg.SenderEmailAddress;
                                                // Add a new recipient CC		
                                                oRecipCc = (Outlook.Recipient)nRecips.Add(ConfigurationManager.AppSettings.Get("strMcdMailAddr"));
                                                oRecipCc.Type = 2;
                                                oRecipCc.Resolve();
                                                nnMsg.Recipients.Add(ConfigurationManager.AppSettings.Get("strMcdMailAddr"));
                                            }
                                            else
                                            {
                                                // Add a new recipient TO	
                                                oRecipTo = (Outlook.Recipient)nRecips.Add(arg);
                                                oRecipTo.Type = 1;
                                                oRecipTo.Resolve();
                                                nnMsg.Recipients.Add(arg);
                                            }
                                            nnMsg.Send();

                                        }

                                    }
                                } bMsg.UnRead = false;
                            }

                        }
                        else
                        {
                            //AddLineToOutput("Read email");                    
                        }
                    }
                }

                Outlook.MailItem rrMsg = (Outlook.MailItem)oApp.CreateItem(Outlook.OlItemType.olMailItem);
                rrMsg.Subject = "";
                rrMsg.Body = "";
                Outlook.Recipients rrRecips = (Outlook.Recipients)rrMsg.Recipients;

                //No valid message(s) found
                if (validMsgCount == 0)
                {
                    /*rrMsg.Subject = "IPCReclassification robot warning";
                    rrMsg.Body = "Script ran, but didn't find valid message in mailbox.";
                    Outlook.Recipient eeRecipTo;

                    
                    eeRecipTo = (Outlook.Recipient)rrRecips.Add(ConfigurationManager.AppSettings.Get("strAdminMailAddr"));
                    eeRecipTo.Type = 1;
                    eeRecipTo.Resolve();
                    rrMsg.Recipients.Add(ConfigurationManager.AppSettings.Get("strAdminMailAddr"));
                    rrMsg.Send();*/
                }
                else
                {
                    //create reply message
                    /*
                    rrMsg.Subject = "IPCReclassification robot information";
                    rrMsg.Body = "Script ran, and found valid message in mailbox." + CRLF + validMsgCount + " valid message(s) found. " + CRLF + AllSaved + " attachment(s) saved.";
                    Outlook.Recipient ooRecipTo;
                    ooRecipTo = (Outlook.Recipient)rrRecips.Add(ConfigurationManager.AppSettings.Get("strAdminMailAddr"));
                    ooRecipTo.Type = 1;
                    ooRecipTo.Resolve();
                    rrMsg.Recipients.Add(ConfigurationManager.AppSettings.Get("strAdminMailAddr"));
                    rrMsg.Send();
                     * */
                }
            }
            catch (Exception ex)
            {
                AddLineToOutput("Error while executing application : " + ex.Message);
            }
            finally
            {
                AddLineToOutput(Environment.NewLine + "End of processing : " + System.DateTime.Now.ToString());
                AddLineToOutput("---------------------------------------------------------------------------");
                Application.Exit();
            }
        }
        #endregion

        #region " Output "
        private void AddLineToOutput(string _newOutputLine)
        {
            newOutputLine = _newOutputLine;
            if (this.InvokeRequired)
            {
                Invoke(new delegateNoParam(InvokeAddLineToOutput));
            }
            else
            {
                InvokeAddLineToOutput();
            }
        }

        private void InvokeAddLineToOutput()
        {
            //add new line to outputVar
            outputLines.AppendLine(newOutputLine);
            //add line to direct output
            textBox1.Text = outputLines.ToString();
            //add line to log file
        }
        #endregion
    }

}
